*( YESNO.CMD--Display a simulated yes/no dialog box. You choose )
*( the message, Yes or No as the default answer, and the display position.)
SET MESSAGES OFF ; SET ERROR MESSAGES OFF
SET VAR %1 TEXT, %2 TEXT, %3 INTEGER
IF %1 IS NULL OR %2 IS NULL OR %3 IS NULL THEN
  WRITE ' ' ; WRITE 'Correct syntax is:'
  *( When you want to display a single quotation mark in a message )
  *( written by a WRITE command, insert two single quotation marks )
  *( in the message. What looks like a double quotation mark on the )
  *( line below is really two single quotation marks. Because the )
  *( line to be displayed ends in a single quotation mark, the command )
  *( ends in three single quotation marks.)
  WRITE 'RUN yesno.cmd USING ''Message'',''Default (Yes/No)'',''line'''
  SET MANY=* ; CLEAR VAR %1, %2, %3 ; SET MANY=%
  RETURN
ENDIF
SET VAR vyesno_pos INT=(IFEQ(.%2,'Yes',0,1))
SET VAR v32=(CHAR(32)), v255=(CHAR(255))
SET VAR vst_line1=.%3, vst_line1 INT, vst_line2 INT=(.vst_line1 + 1)
SET VAR vst_line3 INT=(.vst_line1 + 2), vst_line4 INT=(.vst_line1 + 3)
SET VAR vst_line5 INT=(.vst_line1 + 4), vst_line6 INT=(.vst_line1 + 5)
SET VAR vyn_line=.vst_line3, vmess_width=(SLEN(.%1))
IF vmess_width > 50 THEN; SET VAR %1=(SGET(.%1,50,1)), vmess_width=50
ENDIF
SET VAR v201=(CHAR(201)), v205=(CHAR(205)), v187=(CHAR(187)), +
  v200=(CHAR(200)), v219=(CHAR(219)), v188=(CHAR(188)), +
  v186=(CHAR(186)), vfill_amt=(.vmess_width + 16)
SET VAR vtop_line=(.v201 + SFIL(.v205,.vfill_amt) + .v187)
SET VAR vbottom_line=(.v200 + SFIL(.v205,.vfill_amt) + .v188 + .v219 + .v219)
SET VAR vbottom_shade=(SFIL(.v219,.vfill_amt) + .v219 + .v219)
SET VAR vblank_line=(.v186 + SFIL(.v32,.vfill_amt) + .v186 + .v219 + .v219)
SET VAR vyn_mess=(.v186+.v255+.v255+LJS(.%1,.vmess_width) +
  + '     Yes  No' + .v255 + .v255 + .v186 + .v219 + .v219)
SET VAR vstart_col=(INT((80 - (.vmess_width + 18)) / 2))
SET VAR vstart_shade=(.vstart_col + 2)
SET VAR vstart_y=(.vstart_col + .vmess_width + 7)
SET VAR vstart_n = (.vstart_col + .vmess_width + 12), vtnull TEXT
SNAP save.$$$ FROM .vst_line1 .vstart_col TO .vst_line6 79
WRITE .vtop_line AT .vst_line1 .vstart_col BLACK ON CYAN
WRITE .vblank_line AT .vst_line2 .vstart_col BLACK ON CYAN
WRITE .vyn_mess AT .vst_line3 .vstart_col BLACK ON CYAN
WRITE .vblank_line AT .vst_line4 .vstart_col BLACK ON CYAN
WRITE .vbottom_line AT .vst_line5 .vstart_col BLACK ON CYAN
WRITE .vbottom_shade AT .vst_line6 .vstart_shade BLACK ON CYAN
SET VAR vbreak INTEGER = 0
WHILE vbreak <> 99 then
  SWITCH vyesno_pos
    CASE '0'
      WRITE ' Yes ' AT .vyn_line .vstart_y CYAN ON BLACK
      WRITE ' No ' AT .vyn_line .vstart_n BLACK ON CYAN ; BREAK
    CASE '1'
      WRITE ' No ' AT .vyn_line .vstart_n CYAN ON BLACK
      WRITE ' Yes ' AT .vyn_line .vstart_y BLACK ON CYAN ; BREAK
  ENDSW
  FILLIN xxx=0 AT 1, 1
  SWITCH (.xxx)
    CASE '[Left]'
    CASE 'Y' ; SET VAR vyesno_pos=0 ; BREAK
    CASE '[Right]'
    CASE 'N' ; SET VAR vyesno_pos=1 ; BREAK
    CASE '[Enter]'
    CASE '[F2]'
    CASE '[Esc]' ; SET VAR vbreak=99 ; BREAK
    CASE ' ' ; SET VAR vyesno_pos=(MOD(vyesno_pos+1,2)) ; BREAK
  ENDSW
ENDWHILE
SET VAR vyn TEXT=(IFEQ(.vyesno_pos,0,'Yes','No'))
DISPLAY save.$$$ AT .vst_line1 .vstart_col ; DEL save.$$$ ; SET MANY='#'
CLEAR VAR vyesno_pos, v32, vmess_width, vfill_amt, vtop_line, +
  vbottom_line, %1, %2, vblank_line, vyn_mess, vstart_col, vstart_y, +
  vstart_n, vtnull, vbreak, xxx, vst_line1, vst_line2, vst_line3, +
  vst_line4, vst_line5, vst_line6, vyn_line, vbottom_shade, vstart_shade, +
  %3, v201, v205, v187, v200, v219, v188, v186, v255
SET MANY='%'
RETURN

